/***********************************************************************/
/*                                                                     */
/*  FILE        :press02.c                                             */
/*  DATE        :Sun, Jun 07, 2015                                     */
/*  DESCRIPTION :main program file.                                    */
/*  CPU GROUP   :M12A                                                  */
/*                                                                     */
/*  R8C m12a  pressure-sensor LPS25H I2Cœǂ        @@@@@   */
/*              address   7bit 0B1011100(0x5c)                         */
/*                                                                     */
/*              RTC DS3232 I2Cœǂ                                 */
/*              address   7bit@0x68                                   */
/*                                                                     */
/*  R8C m12a  EEPROM 24LS64 I2Cœǂݏ           @@@@@@   */
/*              EEPROM address 0x50(7bit)                              */
/*                                                                     */
/*                                                                     */
/*    //  RTC 0x68   press 0x5c   eeprom 0x50                          */
/*                                                                     */
/*                                                                     */
/*                                                                     */
/*                                                                     */
/*              dataLCDɕ\                                    */
/*              -------                                                */
/*        SCL  1       20  D7(lcd)                                     */
/*        SDA  2       19  D6                                          */
/*      RESET  3       18  D5                                          */
/*             4       17  D4                                          */
/*        GND  5       16  TD                                          */
/*             6       15  RD                                          */
/*        Vcc  7       14  RD programing                               */
/*       MODE  8       13                                              */
/*         sw  9       12  EN(lcd)                                     */
/*   wave out 10       11  RS(lcd)                                     */
/*              -------                                                */
/*                                                                     */
/*                                                                     */
/*  ̗pr̂߂I2C̃[`͎cĂB                        */
/*                                                                     */
/*  |[ǵ@SCL : p4_1i1ԃs)                                     */
/*            SDA : p3_7i2ԃs)                                     */
/*                                                                     */
/***********************************************************************/

#include "sfr_r8m12a.h"
#include <string.h>
#include "lcd.h"

#define s_SCL p4_2=1 // clk H
#define c_SCL p4_2=0 // clk L
#define s_SDA p3_7=1 // data H
#define c_SDA p3_7=0 // data L
#define SDA_IN pd3_7=0 //
#define SDA_OUT pd3_7=1 //
#define SDA_data p3_7 // data port
#define EI() asm("fset i")	//荞݋
#define DI() asm("FCLR I")	//荞݋֎~

void main(void);
void delay(void);
void delay1ms(unsigned int ii);
void start(void);
void stop(void);
void ack(void);
void ack_out(void);
void write_eeprom(short address,unsigned char dat);
unsigned char read_eeprom(short address);
void i2cwrite(unsigned int add,unsigned char dat);
unsigned char i2cread(unsigned char address);
void i2cread_n(unsigned char address,unsigned char n);  //AhXƃoCg@d[0]ɕԂ
void Utx(char data);
char Urx(void);
void Utx_str(char *str); 
void Urx_str(char *s);
void cr(void);


volatile unsigned char d[20]; // oCgǂݎ̃obt@ d[0]珇ɓ
volatile unsigned char AD;    // address 7bit   RTC 0x68   press 0x5c   eeprom 0x50                          */


void main(void)
{
  unsigned int i,j,menu,YY,MM,DD,hh,mm,ss;
  unsigned char wr,x,ctrl_reg,cnt,data,data1,data2;
  char msg[30],s[20];
  short strt,n;
  long pr,pr1,pr2,pr3;
  int t,t1,t2;
  unsigned char m[9], write_flg; //for eeprom write
  short in_add,in_add2;                                          ///////////////////////////////////////
  
  ctrl_reg=0;  //pressure sensor initialize
	DI(); //荞݋֎~

  // System clock Int 20MHz
  prc0=1; //Protect off 
  hocoe=1;
  for(i=0;i<1000;i++){}
  hscksel=1;
  scksel=1;
  prc0=0; //Protect on

   //Set I2C
  pd4_2=1;// SCL OUT
  pd3_7=1;// SDA In or OUT
  s_SDA;  // set SDA
 
  //Set UART0 9600bps
  mstuart = 0;
  p15sel2=0; //P1_5:RX
  p15sel1=0;
  p15sel0=1;
  p14sel2=0; //P1_4:TX
  p14sel1=0;
  p14sel0=1;
  u0mr=0x05; //UART mode:8bit
  u0c0=0x10; //source:f1
  u0brg=129; //f1/(bps*16)-1=20M/(9600*16)-1=129.2
  te_u0c1=1; //TX enable
  re_u0c1=1; //RX enable
  
  //	port_init() |[g̓o̓[hݒ肷B
	pd1 = 0b00001111; //lcd d7-4
	pd3_3 = 1;        //lcd RS
  pd3_4 = 1;        //`g
  pd3_5 = 0;        // SW
	pd4_5 = 1;        //lcd EN

/************************************************************************/
/* R8C/M12A XyVt@NVWX^(SFR)̏               */
/* ^C}RB̐ݒ ?usƂɊ荞݂𔭐*/
    msttrb = 0;                         // ^C}RB2Lɂ        
    trbmr  = 0x00;                      // 샂[hAݒ     
    trbpre = 20-1;                     // vXP[WX^        
    trbpr  = 20-1;                     // vC}WX^           
    trbir  = 0x80;                      // ^C}ݗv             
    ilvlc  = 0x03;                      // ݗD惌xݒ teisi        
    trbcr  = 0x01;                      // JEgJn                 */
	
	EI(); //荞݋

	//kbc̏
	lcd_init();
        lcd_cmd(_LCD_CURSOR_OFF);
        lcd_cmd(_LCD_CLEAR);
	lcd_out(1, 1, "lcd m.");
  strcpy(s,"time ");
	lcd_out(1, 1, s);
  
  //------------------------- get eeprom address  ------------------------------
  in_add=0;
  // 0x00 search
  AD=0x50;
  while(1){
    d[0]=read_eeprom(in_add);
    Utx('0'+d[0]/100);d[0]=d[0]%100;
    Utx('0'+d[0]/10);d[0]=d[0]%10;
    Utx('0'+d[0]);cr();
    
    if(d[0]==0)break;
    in_add += 7;
   
    if(in_add>8100){in_add=14; break;}
  }
    d[0]=(unsigned char)in_add;
    Utx('0'+d[0]/100);d[0]=d[0]%100;
    Utx('0'+d[0]/10);d[0]=d[0]%10;
    Utx('0'+d[0]);cr();
    Utx('Z');cr();
  //------------------------- end get eeprom address  ------------------------------
  

#if 1  // --------------- rtc -------------------------------- 
  
  while(1){
      
      AD= 0x68;  //RTC
      i2cread_n(0x00,7);   //޲ĘAǂݏo@AhX0x00@QoCg@d[0],d[1]
/*       
      Utx_str("time ");
      Utx('0'+d[2]/16); //10
      Utx('0'+d[2]%16); // 1
      Utx(':');
      Utx('0'+d[1]/16);
      Utx('0'+d[1]%16);
      Utx(':');
      Utx('0'+d[0]/16);
      Utx('0'+d[0]%16);
      cr();
*/      
      s[0]='0'+d[6]/16;
      s[1]='0'+d[6]%16; //YY
      s[2]='0'+d[5]/16;
      s[3]='0'+d[5]%16; //MM
      s[4]='0'+d[4]/16;
      s[5]='0'+d[4]%16; //DD
      s[6]=' ';
      s[7]='0'+d[2]/16; //10
      s[8]='0'+d[2]%16; // 1
      s[9]=':';
      s[10]='0'+d[1]/16; //10min
      s[11]='0'+d[1]%16;
      s[12]=':';
      s[13]='0'+d[0]/16; //10sec
      s[14]='0'+d[0]%16;
      s[15]='\0';
      
      if(d[1]%16==5){write_flg=0;}

      if((d[1]%16==0) && (write_flg==0)){ // 0,10,20...  eeprom
        write_flg=1;  // ݏ
        m[0]=d[4]; //DD
        m[1]=d[2]; //hh
        m[2]=d[1]; //mm
      }//if
     	lcd_out(1, 1, s);

/*
//ʑ}@xZT[
    AD=0x48;
    data=i2cread(0x00);
    data=(data&0B01111111);
    data2=(data%10);
    data=(data/10);
//      s[0]='0'+data;
//      s[1]='0'+data2;
//end@ʑ}@xZT[
*/



      AD=0x5c; // pressure-sensor 7bit
      /*  who am I
      x=i2cread(0x0f);               //   x=0xbd;
      Utx('0'+x/100); x=x%100;
      Utx('0'+x/10);  x=x%10;
      Utx('0'+x); 
      cr();
      */
  
      // set ctrl_reg  addr 0x20  data 0x90 
      if(ctrl_reg==0){ i2cwrite(0x20,0x90); }; ctrl_reg=1; //dP񂾂

      
      cnt++;
      if(cnt>50){
        cnt=1;   

 //     	lcd_out(2, 1, s);

        // read press
        pr1=(long)i2cread(0x2a);  // high
        pr2=(long)i2cread(0x29);  // low
        pr3=(long)i2cread(0x28);  // x-low
  
        // read temp
        t1=(long)i2cread(0x2c);  // high
        t2=(long)i2cread(0x2b);  // low
  
  
  
        pr= pr1<<16 | pr2<<8 | pr3;
        pr=pr*10/4096;
        
        if(write_flg==1){
          m[3]=(unsigned char)(pr/256); // eeprom
          m[4]=(unsigned char)(pr%256); // eeprom
        }
        
//        Utx_str("p = ");
        s[0]=' ';
        s[1]=('0'+pr/10000); pr=pr%10000;
        s[2]=('0'+pr/1000); pr=pr%1000;
        s[3]=('0'+pr/100);  pr=pr%100;
        s[4]=('0'+pr/10);   pr=pr%10;
        s[5]=('.'); 
        s[6]=('0'+pr); 
  
        t=t1<<8 |t2;
        t=425+t/48;

        if(write_flg==1){
          m[5]=(unsigned char)(t/256); // eeprom
          m[6]=(unsigned char)(t%256); // eeprom
          
          
          
          
          AD=0x50;  // address 7bit   RTC 0x68   press 0x5c   eeprom 0x50    
/*          
          write_eeprom(in_add+0,m[0]); delay1ms(6);
          write_eeprom(in_add+1,m[1]); delay1ms(6);
          write_eeprom(in_add+2,m[2]); delay1ms(6);
          write_eeprom(in_add+3,m[3]); delay1ms(6);
          write_eeprom(in_add+4,m[4]); delay1ms(6);
          write_eeprom(in_add+5,m[5]); delay1ms(6);
          write_eeprom(in_add+6,m[6]); delay1ms(6);
          in_add =in_add+ 7;
          if(in_add>8100){in_add=0;}
          write_eeprom(in_add,0x00); delay1ms(6);
*/          
          for(i=0;i<7;i++){
            write_eeprom(in_add,m[i]); delay1ms(6); in_add++;
          }//for i
          if(in_add>8100){in_add=0;}
          write_eeprom(in_add,0x00); delay1ms(6);
          
          write_flg=2;
        }
        
        s[7]=' ';
        s[8]=' ';
        s[9]=' ';
        s[10]=('0'+t/100); t=t%100;
        s[11]=('0'+t/10); t=t%10;
        s[12]=('.'); 
        s[13]=('0'+t);
        s[14]=(' ');
       	lcd_out(2, 1, s);
      } //if
      delay1ms(130);

      if(p3_5==0){  // menu sw on
      // ------- menu -----------------
      Utx_str("--- MENU ---"); cr();
      Utx_str(" 1  ݒ"); cr();
      Utx_str(" 2  f[^ǂݏo"); cr();
      Utx_str(" 1`2 ? "); cr();
  
      menu=Urx()-'0';  cr();
      
          if(menu==1){ //ݒ
            Utx_str("24 YYMMDDhhmmss ͂ĂB"); cr();
            Urx_str(s);cr();
            
            ss=(s[10]-'0')*16+(s[11]-'0');
            mm=(s[8]-'0')*16+(s[9]-'0');
            hh=(s[6]-'0')*16+(s[7]-'0');
            DD=(s[4]-'0')*16+(s[5]-'0');
            MM=(s[2]-'0')*16+(s[3]-'0');
            YY=(s[0]-'0')*16+(s[1]-'0');
            AD=0x68;
            i2cwrite(0,ss);
            i2cwrite(1,mm);
            i2cwrite(2,hh);
            i2cwrite(4,DD);
            i2cwrite(5,MM);
            i2cwrite(6,YY);
          }//end ݒ
  
          if(menu==2){  //f[^ǂݏo
            AD=0x50;
            in_add2=0;
            for(i=0;i<1158;i++){
              for(j=0;j<8;j++){
                m[j]=read_eeprom(in_add2+j);
              }//for j
              
              Utx('0'+m[0]/16);
              Utx('0'+m[0]%16);
              Utx(',');
              Utx('0'+m[1]/16);
              Utx('0'+m[1]%16);
              Utx(',');
              Utx('0'+m[2]/16);
              Utx('0'+m[2]%16);
              Utx(',');
              Utx(' ');
              
              pr=m[3]*256+m[4];
              Utx('0'+pr/10000); pr=pr%10000;
              Utx('0'+pr/1000); pr=pr%1000;
              Utx('0'+pr/100); pr=pr%100;
              Utx('0'+pr/10); pr=pr%10;
              Utx('.');
              Utx('0'+pr);
              Utx(',');
              Utx(' ');
              
              t=m[5]*256+m[6];
              Utx('0'+t/100); t=t%100;
              Utx('0'+t/10); t=t%10;
              Utx('.');
              Utx('0'+t);
              cr();
              
              in_add2=in_add2+7;
            } //for  
          } //end f[^ǂݏo        
      }//if p3_5

  }

#endif  // --------------- rtc --------------------------------
}
/*  *********************end of main ********************************************************** */


//-----------------------@Us@delay@------------------------
void delay(void){
 unsigned char i;
 for(i=0;i<5;i++){}//delay 6Us
} //delay

//--------------- delay 1 ms --------------------------------------
void delay1ms(unsigned int ii){   // delay() 142 l
  int i;
  while(ii>0){
    for(i=1;i<142;i++){ delay();}
    ii--;
  }
}  

 
//--------------------X^[gERfBVs(m[}As[g̋ʂȂ)---
void start(void){
 s_SDA;// set SDA
 s_SCL; // set CLK
 delay();
 c_SDA; // clear SDA
 c_SCL; // clear CLK
 delay();
 }

// --------------------XgbvERfBVs------------
void stop(void){
 c_SDA; // clear SDA
 s_SCL; // set CLK
 delay();
 s_SDA;// set SDA
 c_SCL; // clear CLK
 delay();
 }

//---------------------------------------------------------------
void Hclk(void){//SDAhigh1NbN
 s_SDA;// set SDA
 s_SCL; // set CLK
 delay();
 c_SCL; // clear CLK
 delay();
 }

//-----------------------------------------------------------------
void Lclk(void){//SDAlow1NbN
 c_SDA; // clear SDA
 s_SCL; // set CLK
 delay();
 c_SCL; // clear CLK
 delay();
 }

//----------------------------------------------------------------
void ack(void){
 SDA_IN;
 s_SCL; // set CLK
 delay();
 c_SCL; // clear CLK
 delay();
 SDA_OUT;
 }

//----------------------------------------------------------------
void ack_out(void){
 SDA_OUT;
  c_SDA; // clear SDA
 s_SCL; // set CLK
 delay();

//-----------------------------------------------------------------
 c_SCL; // clear CLK
 delay();
 SDA_IN;
 }

//-------------------- i2c@1oCg݁@------------------------
void i2cwrite(unsigned int add,unsigned char dat){//
 unsigned int k;
 unsigned char i;
 start();
 i=AD<<1;
 for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
 ack();//ACK
 i=add; //
 for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
 ack();//ACK
 i=dat; //
 for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
 ack();//ACK
 stop();//Stop
 }

//---------------------- i2c@1oCgǂݎ@---------------------------
unsigned char i2cread(unsigned char address){
 unsigned char i;
 unsigned int k;
 start();
 i=AD<<1;
 for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
 ack();//ACK
 i=address; //
 for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
 ack();//ACK
 start();
 i=(AD<<1)+0B00000001;
 for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
 ack();//ACK        
 SDA_IN; //SDA͂ɕύX
 i=0;
 for(k=0B10000000;k>0;k=k>>1){
  s_SCL; // set CLK
  delay();  
  if(SDA_data)i+=k;
  c_SCL; // clear CLK
  delay();
  }
 SDA_OUT; //SDAo͂ɕύX
 ack();//ACK
 stop();//Stop
 return i;
 }


//-------------------------- i2c n oCgǂݎ@-----------------------------------
void i2cread_n(unsigned char address,unsigned char n){    //address=inner  n=read bytes
 unsigned char i,j;
 unsigned int k;
 start();
 
 i=AD<<1;
 for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
 ack();//ACK
 i=address; //
 for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
 ack();//ACK
 start();

 i=(AD<<1)+0B00000001;
 for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
 ack();//ACK        

  j=0;
  while(n){ 
    SDA_IN; //SDA͂ɕύX
    i=0; 
    for(k=0B10000000;k>0;k=k>>1){
      s_SCL; // set CLK
      delay();  
      if(SDA_data)i+=k;
      c_SCL; // clear CLK
      delay();
    }
    SDA_OUT; //SDAo͂ɕύX
    if(n==1){ack;}else{ack_out();}//ACK
    d[j]=i;
    n--;
    j++;
  }    
 stop();//Stop
 }

//------------------------ UART@PM-------------------------------
void Utx(char data){    //
 while(ti_u0c1 != 1){}; // f[^]҂
 u0tbl = data;  // Mobt@(U0TBL)Ƀf[^Zbg
 }       

//------------------------- UART@PM-------------------------------
char Urx(void){   //
 int data0;
    char data;    // Mf[^i[ϐ
    while (ri_u0c1 != 1){}; // M҂
 data0 = u0rb;   // Mf[^̎o
 data=(char)data0;
    return data;
 }


//------------------------------ t`qs񑗐M[` --------------------------

void Utx_str(char *str){   /* "*"Ŏ󂯂ƁAĂяo̔z̔Ԓn󂯎 */ 
  while ( *str != '\0'){                    //(msg_string[i]  !='\0'){
    while(ti_u0c1 != 1){}; // f[^]҂
    u0tbl = (*str);  // Mobt@(U0TBL)Ƀf[^Zbgmmsg[i];
    str++;
  }       
}

//------------------------- UART@@M-------------------------------
void Urx_str(char *s){   //
  unsigned char i;
  i=0;
  while (i<16){       // *s != '\r'
    s[i]=Urx();
    if(s[i]=='\n') break;
    if(s[i]==13) break; // cr
    i++;
  }
}

//-----------------------@uart@CRLFM@--------------------------------------
void cr(void){
  while(ti_u0c1 != 1){}; u0tbl = ('\n');  // CR
  while(ti_u0c1 != 1){}; u0tbl = ('\r');  // LF
}

/*@**********ȉ@EEPROM̂߂ɒǉ@********************************************@*/

//-------------------- eeprom@1oCg݁@------------------------
void write_eeprom(short address,unsigned char dat){//
  unsigned int k;
  unsigned char i,h,l;
 
//  h = address >> 8;
//  l = address & 0xff;
  h = address/256;
  l = address%256;
  
  start();
  i=AD<<1;
  for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
  ack();//ACK
  i=h; //
  for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
  ack();//ACK
  i=l; //
  for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
  ack();//ACK
  i=dat; //
  for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
  ack();//ACK
  stop();//Stop
 }

//---------------------- i2c eeprom@1oCgǂݎ@---------------------------
unsigned char read_eeprom(short address){
  unsigned int k;
  unsigned char i,h,l;
  
  h = address >> 8;
  l = address & 0xff;
  
  start();
  i=AD<<1;
  for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
  ack();//ACK
  i=h; //
  for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
  ack();//ACK
  i=l; //
  for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
  ack();//ACK
  start();
  i=(AD<<1)+0B00000001;
  for(k=0B10000000;k>0;k=k>>1)if(k & i)Hclk();
        else Lclk();
  ack();//ACK        
  SDA_IN; //SDA͂ɕύX
  i=0;
  for(k=0B10000000;k>0;k=k>>1){
   s_SCL; // set CLK
   delay();  
   if(SDA_data)i+=k;
   c_SCL; // clear CLK
   delay();
  }
  SDA_OUT; //SDAo͂ɕύX
  ack();//ACK
  stop();//Stop
  return i;
 }

//------------------------------------------------------------------------------

/************************************************************************/
/* ^C}RB 荞ݏ                                 */
/************************************************************************/
#pragma interrupt intTRB(vect=24)
void intTRB( void )
{
    trbif_trbir = 0;                    /* tÕNA               */

    p3_4 = ~p3_4;
}

